module Terse

    # A class storing all information about a keyword & what it should be transformed into 
    class Keyword
        attr_accessor :keyword
        attr_accessor :substitute
        attr_accessor :regex
        attr_accessor :follow_on_regex
        attr_accessor :follow_on_substitute
        attr_accessor :try_follow_on_regex
        attr_accessor :needs_top_level_start
        attr_accessor :needs_inner_start
        attr_accessor :needs_top_level_end
        attr_accessor :needs_inner_end
        attr_accessor :is_end

        # some keywords naturally imply that the line should have a line-ending, e.g. ; for Java 
        # line-endings should not be applied if the keyword indicates the start/end of a class/method/block, etc.
        # Internally, :needs_top_level_end and :needs_inner_end take priority over :needs_line_ending
        attr_accessor :needs_line_ending 

        def initialize(keyword)
            @keyword = keyword
            @regex = gen_regex_from_keyword keyword
            @follow_on_regex = gen_regex_from_keyword_including_follow_on keyword
        end
        
        # # TODO this doesn't work, needs to process the thing following the keyword, not the keyword itself
        # def set_substitute
        #     case @keyword
        #         when "a", "r", "w"
        #             @substitute = ":" + @substitute
        #         when "req", "reqr"
        #             @substitute = "\"" + @substitute + "\"" unless ["\"", "'"].include? @substitute[0]
        #     end
        # end
        
        
        
        # # @substitutes = %W{ require require_relative include class method def end attr_accesor attr_reader attr_writer }

            
        # # def generate_regexes
        # #     r = []
        # #     for i in 0 ... @keywords.size
        # #         r << Keyword.new(@keywords[i], @substitutes[i], gen_regex_from_keyword(@keywords[i]))
        # #     end
        # #     r
        # # end

        # # Simple regex to match a keyword at the start of a line
        # def gen_regex_from_keyword keyword
        #     return /(^\s*)(#{keyword})(\s+|$)/
        # end
        
        # # Regex to match a keyword at the start of a line, and the next word on that line
        # # E.g. this will also catch (in $3) the item following the "require" keyword
        # # This enables the routine to format this follow-on word, e.g. to turn 'req a_gem' into
        # # 'require "a_gem"'
        # def gen_regex_from_keyword_including_follow_on keyword
        #     return /(^\s*)(#{keyword})\s+([a-zA-Z0-9_]+)/
        # end
        
        # def self.generate_ruby_keywords
        #     keywords = []
        #     keys = [:req, :reqr, :i, :c, :m, :d, :e, :a, :r, :w]
        #     keys.each do |key|
        #         k = Keyword.new key
        #         # k.keyword = key
        #         case key
        #             when :req
        #                 k.substitute = "require"
        #                 k.try_follow_on_regex = true
        #                 k.follow_on_substitute = "\"\#{$3}\""
        #             when :reqr
        #                 k.substitute = "require_relative"
        #                 k.try_follow_on_regex = true
        #                 k.follow_on_substitute = "\"\#{$3}\""
        #             when :i
        #                 k.substitute = "include"
        #             when :c
        #                 k.substitute = "class"
        #                 k.needs_top_level_end = true
        #             when :m
        #                 k.substitute = "module"
        #                 k.needs_top_level_end = true
        #             when :d
        #                 k.substitute = "def"
        #                 k.needs_inner_end = true
        #             when :e
        #                 k.substitute = "end"
        #                 k.is_end = true
        #             when :a
        #                 k.substitute = "attr_accessor"                    
        #                 k.try_follow_on_regex = true
        #                 k.follow_on_substitute = "$3.to_sym"#"\":\#{$3}\""
        #             when :r
        #                 k.substitute = "attr_reader"              
        #                 k.try_follow_on_regex = true
        #                 k.follow_on_substitute = "$3.to_sym"
        #             when :w
        #                 k.substitute = "attr_writer"              
        #                 k.try_follow_on_regex = true
        #                 k.follow_on_substitute = "$3.to_sym"
                    
        #         else
        #             # raise "Unknown keyword #{key}"
        #             puts "Unknown keyword #{key}"
        #         end
        #         keywords << k
        #     end # end keys.each
        #     keywords
        # end

        # def self.generate_java_keywords
        #     keywords = []
        #     keys = [:imp, :c, :ex, :inc, :ab, :e, :st, :v, :m, :p, :pt, :pv, :r, :s, :i, :b, :f, :fn]
        #     keys.each do |key|
        #         k = Keyword.new key
        #         # k.keyword = key
        #         case key
        #             when :imp
        #                 k.substitute = "import"
        #                 k.try_follow_on_regex = true
        #                 k.follow_on_substitute = "\"\#{$3}\""
        #             when :reqr
        #                 k.substitute = "require_relative"
        #                 k.try_follow_on_regex = true
        #                 k.follow_on_substitute = "\"\#{$3}\""
        #             when :i
        #                 k.substitute = "include"
        #             when :c
        #                 k.substitute = "class"
        #                 k.needs_top_level_end = true
        #             when :m
        #                 k.substitute = "module"
        #                 k.needs_top_level_end = true
        #             when :d
        #                 k.substitute = "def"
        #                 k.needs_inner_end = true
        #             when :e
        #                 k.substitute = "end"
        #                 k.is_end = true
        #             when :a
        #                 k.substitute = "attr_accessor"                    
        #                 k.try_follow_on_regex = true
        #                 k.follow_on_substitute = "$3.to_sym"#"\":\#{$3}\""
        #             when :r
        #                 k.substitute = "attr_reader"              
        #                 k.try_follow_on_regex = true
        #                 k.follow_on_substitute = "$3.to_sym"
        #             when :w
        #                 k.substitute = "attr_writer"              
        #                 k.try_follow_on_regex = true
        #                 k.follow_on_substitute = "$3.to_sym"
                    
        #         else
        #             # raise "Unknown keyword #{key}"
        #             puts "Unknown keyword #{key}"
        #         end
        #         keywords << k
        #     end # end keys.each
        #     keywords
        # end
    end
end