require "argv"
require_relative "terse/scan"
require_relative "terse/settings"

module TerseRuby

    # Routing method to call the proper method
    def self.scan_files argv
        puts "\nTerse Ruby called"
        settings = Terse::Settings.new
        settings.lang = :ruby
        settings.file_ext = "rb"
        settings.one_keyword_per_line = true
        settings.loop_ending = "end"
        settings.line_ending = ""
        settings.indent_in = ["class", "module", "def"] #, "do"] # TODO add "do", adjust indent_in_regex accordingly
        settings.indent_in_regex = /^\s*([a-zA-Z0-9_]+)\s+|$/ # indent-in keywords should be the first words on a given line
        settings.indent_out = ["end"]
        settings.indent_out_regex = /^\s*([a-zA-Z0-9_]+)\s*$/ # indent-out keywords should be the only words on a given line
        Terse::Scan.scan_files settings, argv
    end
end

module TerseJava
	include TerseRuby

    # Routing method to call the proper method
    def self.scan_files argv
    	puts "\nTerse Java called"
        settings = Terse::Settings.new
        settings.lang = :java
        settings.file_ext = "java"
        settings.one_keyword_per_line = false
        settings.loop_start = "{"
        settings.loop_ending = "}"
        settings.line_ending = ";"
        settings.indent_in = ["{"]
        settings.indent_in_regex = /({)\s*$/ # indent-in keywords may not be the first words on a given line
        settings.indent_out = ["}"]
        settings.indent_out_regex = /(})\s*$/ # } is a relatively unused char (outside of loop-endings) that this regex does nto need to be sophisticated
        Terse::Scan.scan_files settings, argv
    end
end